/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Available Patches
// #define USE_GRAY_PATCH
#define USE_LONGMUL_PATCH
#define USE_LONGDIV_PATCH
// #define USE_INITS_PATCH

#define SAVE_SCREEN  // Save/Restore LCD Contents

#include <nostub.h>  // Make NoStub Program
#include <all.h>     // Include All Header Files

int _ti89;           // Produce .89Z File
int _ti92plus;       // Produce .9XZ File

//Constantes globales
char 	*gunN[] = {"AK-47 Rifle     ", "Bizon SMG       ", "Makarov Pistol  ", "M-16 Rifle      ", "MAC 10 SMG      ", "Colt 1911 Pistol", "FN FAL Rifle    ", "MP5K SMG        ", "Glock 17 Pistol ", "Type 85 Rifle   ", "None"},
			*gunD[] = {"This rifle is the more widely\nused worldwide.", "A nice SMG used by russian\nspetnaz.", "A popular pistol among the\nsoviet officers during\ncold war.", "The old good american rifle.", "The old good american SMG.", "The old good american pistol.", "This weapon was very popular in the sixties'.", "This SMG is greatly\napreciated by special forces\nworldwide.", "A very popular police pistol.", "A cheap chinese bullpup\nAK clone."},
			*loca[] = {"Paris, France", "Moscow, Russia", "New York, USA", "Ryo, Brazil", "Shanghai, PRC"},
			*manuf[] = {"Kalashnikov", "Kalashnikov", "Kalashnikov", "Colt", "Ingram", "Colt", "Fabrique Nationnale", "Heckler und Kock", "Glock", "State's factories"};

long	gunP[] = {10, 8, 2, 11, 6, 3, 12, 7, 4, 9, 0},
			prMin[] = {100, 200, 5, 1000, 800, 50, 2000, 4000, 500, 50},
			prMax[] = {200, 500, 50, 2000, 1500, 200, 3000, 6000, 800, 100};
BOOL	hand[] = {FALSE, FALSE, TRUE, FALSE, TRUE, TRUE, FALSE, TRUE, TRUE, FALSE, FALSE};

//Variables globales
long	stock[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			prices[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			debt = 0,
			cash = 0,
			loc = 0,
			days = 0,
			health = 0,
			cargo = 0,
			cLim = 0,
			brwMax = 0,
			wepChoice = 0,
			nbrChoice = 0,
			inter = 0;

//Dclaration des fonctions
void dlgBuy (int);
void dlgSell (int);
void menuInven();
void menuLoan();
void menuBuySell();
void menuPedia();
int menuPlane();
int menuJeu();
int menuMain();
void msgWelcome();
void msgAbout();
void msgFinal();
void msgBye();
void saveGame();
void loadGame();
BOOL demand();
void battle(char*, long, long);
void event();
void rndmize();
void rndPrices();
void varIni();
void boucleJeu();
void startGame();
void contGame();

//Dialogues
void dlgBuy(int i)
{
	int select;
	long	amount = cash / prices[i],
				cg = cargo;
			
	if (!hand[i])
	{
		cg = cargo / 2;
	}

	if (amount > cg)
	{
		amount = cg;
	}

	do
	{
		clrscr();
		printf("Buy some "); printf(gunN[i]); printf("\n");
		printf("\n");
		printf("Price: $"); printf("%ld", prices[i]); printf("\n");
		printf("Range: $"); printf("%ld", prMin[i]); printf("-"); printf("%ld", prMax[i]); printf("\n");
		printf("Cash : $"); printf("%ld", cash); printf("\n");
		printf("Stock: "); printf("%ld", stock[i]); printf("\n");
		printf("Cargo: "); printf("%ld", cargo); printf("\n");
		printf("\n");
		printf("Buy "); printf("%ld", amount); printf(" "); printf(gunN[i]); printf("\n");
		printf("for $"); printf("%ld", amount * prices[i]); printf(".");
		
		select = ngetchx();
		
		if (select == KEY_LEFT)
		{
			if ((amount - 1) >= 0)
			{
				amount = amount - 1;
			}
		}
		if (select == KEY_RIGHT)
		{
			if ((amount + 1) * prices[i] <= cash && (amount + 1) <= cg)
			{
				amount = amount + 1;
			}
		}
		if (select == KEY_DOWN)
		{
			if ((amount - 10) >= 0)
			{
				amount = amount - 10;
			}
			else
			{
				amount = 0;
			}
		}
		if (select == KEY_UP)
		{
			if ((amount + 10) * prices[i] <= cash && (amount + 10) <= cg)
			{
				amount = amount + 10;
			}
			else
			{
				amount = cash / prices[i];
				if (amount > cg)
				{
					amount = cg;
				}
			}
		}
		if (select == 264)
		{
			amount = 0;
		}
	}
	while (select != 13 && select != 264);
	cash = cash - amount * prices[i];
	stock[i] = stock[i] + amount;
	if (!hand[i])
	{
		amount = amount * 2;
	}
	cargo = cargo - amount;
}

void dlgSell(int i)
{
	int select;
	long	amount = stock[i];

	do
	{
		clrscr();
		printf("Sell some "); printf(gunN[i]); printf("\n");
		printf("\n");
		printf("Price: $"); printf("%ld", prices[i]); printf("\n");
		printf("Cash : $"); printf("%ld", cash); printf("\n");
		printf("Range: $"); printf("%ld", prMin[i]); printf("-"); printf("%ld", prMax[i]); printf("\n");
		printf("Stock: "); printf("%ld", stock[i]); printf("\n");
		printf("Cargo: "); printf("%ld", cargo); printf("\n");
		printf("\n");
		printf("Sell "); printf("%ld", amount); printf(" "); printf(gunN[i]); printf("\n");
		printf("for $"); printf("%ld", amount * prices[i]); printf(".");
		
		select = ngetchx();
		
		if (select == KEY_LEFT)
		{
			if ((amount - 1) >= 0)
			{
				amount = amount - 1;
			}
		}
		if (select == KEY_RIGHT)
		{
			if ((amount + 1) <= stock[i])
			{
				amount = amount + 1;
			}
		}
		if (select == KEY_DOWN)
		{
			if ((amount - 10) >= 0)
			{
				amount = amount - 10;
			}
			else
			{
				amount = 0;
			}
		}
		if (select == KEY_UP)
		{
			if ((amount + 10) <= stock[i])
			{
				amount = amount + 10;
			}
			else
			{
				amount = stock[i];
			}
		}
		if (select == 264)
		{
			amount = 0;
		}
	}
	while (select != 13 && select != 264);
	cash = cash + amount * prices[i];
	stock[i] = stock[i] - amount;
	
	if (!hand[i])
	{
		amount = amount * 2;
	}
	cargo = cargo + amount;
}

//Menus
void menuInven()
{
	int select,
			i;

	do
	{
		clrscr();
		printf("Your inventory\n");
		printf("Cash  : "); printf("$"); printf("%ld", cash); printf("\n");
		printf("Health: "); printf("%ld", health); printf("%% "); printf("Free cargo: "); printf("%ld", cargo); printf("\n");
		printf("Selected Weapon:\n");
		printf(((nbrChoice == 2) ? "Two " : "")); printf(gunN[wepChoice]); printf("\n");
		for (i=0; i<5; i++)
		{
			printf("%d", i+1); printf(". "); printf(gunN[i]); printf(" - "); printf("%ld", stock[i]); printf("\n");
		}
		printf("\n");
		printf("Press ENTER to continue ...");

		select = ngetchx();
		
		if (select == 13)
		{
			clrscr();
			printf("Your inventory\n");
			printf("Cash      : "); printf("$"); printf("%ld", cash); printf("\n");
			printf("Health: "); printf("%ld", health); printf("%% "); printf("Free cargo: "); printf("%ld", cargo); printf("\n");
			printf("Selected Weapon:\n");
			printf(((nbrChoice == 2) ? "Two " : "")); printf(gunN[wepChoice]); printf("\n");
			for (i=5; i<9; i++)
			{
				printf("%d", i+1); printf(". "); printf(gunN[i]); printf(" - "); printf("%ld", stock[i]); printf("\n");
			}
			
			printf("a. "); printf(gunN[i]); printf(" - "); printf("%ld", stock[i]); printf("\n");
			printf("b. Unselect weapon"); printf("\n");
			
			select = ngetchx();
		}
		switch (select)
		{
			case 97:
			{
				select = 10;
				break;
			}
			case 98:
			{
				select = 11;
				break;
			}
			default:
			{
				if (select != 13 && select != 264)
				{
					select = select - 48;
				}
			}
		}
	}
	while ((select < 0 || select > 11) && select != 13 && select != 264);

	if (select != 13 && select != 264)
	{

			stock[wepChoice] = stock[wepChoice] + nbrChoice;
			cargo = cargo - ((hand[wepChoice]) ? nbrChoice : nbrChoice * 2);
			wepChoice = select - 1;
			
			if (stock[wepChoice] == 0)
			{
				wepChoice = 10;
			}
			
			nbrChoice = 0;
			if (stock[wepChoice] >= 1)
			{
				nbrChoice = 1;
				if (stock[wepChoice] >= 2 && hand[wepChoice])
				{
					nbrChoice = nbrChoice + 1;
				}
			}
			stock[wepChoice] = stock[wepChoice] - nbrChoice;
			cargo = cargo + ((hand[wepChoice]) ? nbrChoice : nbrChoice * 2);		
	}
}

void menuLoan()
{
	int select;
	long	amount;
	
	brwMax = cLim - debt + (cash - debt);
	if (brwMax < 0)
	{
		brwMax = 0;
	}
	
	clrscr();
	printf("Loan shark\n");
	printf("1. Borrow\n");
	printf("2. Repay\n");
	printf("ESC to cancel");
	
	do
	{
		select = ngetchx();
	}
	while ((select < 49 || select > 50) && select != 264);
	
	switch (select)
	{
		case 49:
		{
			amount = 0;
			do
			{
				clrscr();
				printf("Borrow how much ?\n");
				printf("Debts: $"); printf("%ld", debt); printf("\n");
				printf("Limit: $"); printf("%ld", brwMax); printf("\n");
				printf("Cash : $"); printf("%ld", cash); printf("\n");
				printf("\n");
				printf("\n");
				printf("Borrow $"); printf("%ld", amount);
			
				select = ngetchx();
				
				if (select == KEY_LEFT)
				{
					if ((amount - 100) >= 0)
					{
						amount = amount - 100;
					}
					else
					{
						amount = 0;
					}
				}
				if (select == KEY_RIGHT)
				{
					if ((amount + 100) <= brwMax)
					{
						amount = amount + 100;
					}
					else
					{
						amount = brwMax;
					}
				}
				if (select == KEY_DOWN)
				{
					if ((amount - 1000) >= 0)
					{
						amount = amount - 1000;
					}
					else
					{
						amount = 0;
					}
				}
				if (select == KEY_UP)
				{
					if ((amount + 1000) <= brwMax)
					{
						amount = amount + 1000;
					}
					else
					{
						amount = brwMax;
					}
				}
				if (select == 264)
				{
					amount = 0;
				}
			}
			while (select != 13 && select != 264);
			cash = cash + amount;
			debt = debt + amount;
			break;
		}
		case 50:
		{
			amount = debt;
			if (debt > cash)
			{
				amount = cash;
			}
			
			do
			{
				clrscr();
				printf("Repay how much ?\n");
				printf("Debts: $"); printf("%ld", debt); printf("\n");
				printf("Limit: $"); printf("%ld", brwMax); printf("\n");
				printf("Cash : $"); printf("%ld", cash); printf("\n");
				printf("\n");
				printf("\n");
				printf("Repay $"); printf("%ld", amount);
			
				select = ngetchx();
				
				if (select == KEY_LEFT)
				{
					if ((amount - 100) >= 0)
					{
						amount = amount - 100;
					}
					else
					{
						amount = 0;
					}
				}
				if (select == KEY_RIGHT)
				{
					if ((amount + 100) <= debt && (amount + 100) <= cash)
					{
						amount = amount + 100;
					}
					else
					{
						amount = debt;
						if (amount > cash)
						{
							amount = cash;
						}
					}
				}
				if (select == KEY_DOWN)
				{
					if ((amount - 1000) >= 0)
					{
						amount = amount - 1000;
					}
					else
					{
						amount = 0;
					}
				}
				if (select == KEY_UP)
				{
					if ((amount + 1000) <= debt && (amount + 1000) <= cash)
					{
						amount = amount + 1000;
					}
					else
					{
						amount = debt;
						if (amount > cash)
						{
							amount = cash;
						}
					}
				}
				if (select == 264)
				{
					amount = 0;
				}
			}
			while (select != 13 && select != 264);
			cash = cash - amount;
			debt = debt - amount;
			break;
		}
	}
}

void menuBuySell()
{
	int select,
			i;

	do
	{
		clrscr();
		printf("Cash  : "); printf("$"); printf("%ld", cash); printf("\n");
		printf("Free cargo: "); printf("%ld", cargo); printf("\n");
		printf("\n");
		printf("Prices:\n");
		for (i=0; i<5; i++)
		{
			printf("%d", i+1); printf(". "); printf(gunN[i]); printf(" - $"); printf("%ld", prices[i]); printf("\n");
		}
		printf("\n");
		printf("Press ENTER to continue ...");

		select = ngetchx();
		
		if (select == 13)
		{
			clrscr();
			printf("Cash  : "); printf("$"); printf("%ld", cash); printf("\n");
			printf("Free cargo: "); printf("%ld", cargo); printf("\n");
			printf("\n");
			printf("Prices:\n");
			for (i=5; i<9; i++)
			{
				printf("%d", i+1); printf(". "); printf(gunN[i]); printf(" - $"); printf("%ld", prices[i]); printf("\n");
			}
			printf("a. "); printf(gunN[i]); printf(" - $"); printf("%ld", prices[i]); printf("\n");

			select = ngetchx();
		}
				
		switch(select)
		{
			case 97:
			{
				select = 10;
				break;
			}
			default:
			{
				if (select != 13 && select != 264)
				{
					select = select - 48;
				}
			}
		}
	}
	while ((select < 0 || select > 10) && select != 13 && select != 264);
	
	i = select - 1;
	
	if (select != 13 && select != 264)
	{
		clrscr();
		printf(gunN[i]); printf(" - $"); printf("%ld", prices[i]); printf("\n");
		printf("1. Buy\n");
		printf("2. Sell\n");
		printf("ESC to cancel\n");
		
		do
		{
			select = ngetchx();
		}
		while((select < 49 || select > 50) && select != 264);
		
		switch (select)
		{
			case 49:
			{
				dlgBuy(i);
				break;
			}
			case 50:
			{
				dlgSell(i);
				break;
			}
		}
	}
}

void menuPedia()
{
	int select,
			i;

	do
	{
		clrscr();
		printf("GUN-O-PEDIA\n");
		printf("\n");
		for (i=0; i<5; i++)
		{
			printf("%d", i+1); printf(". "); printf(gunN[i]); printf("\n");
		}
		printf("\n");
		printf("\n");
		printf("\n");
		printf("\n");
		printf("Press ENTER to continue ...");

		select = ngetchx();
		
		if (select == 13)
		{
			clrscr();
			printf("GUN-O-PEDIA\n");
			printf("\n");
			for (i=5; i<9; i++)
			{
				printf("%d", i+1); printf(". "); printf(gunN[i]); printf("\n");
			}
			printf("a. "); printf(gunN[i]); printf("\n");

			select = ngetchx();
		}
				
		switch(select)
		{
			case 97:
			{
				select = 10;
				break;
			}
			default:
			{
				if (select != 13 && select != 264)
				{
					select = select - 48;
				}
			}
		}
	}
	while ((select < 0 || select > 10) && select != 13 && select != 264);
	
	if (select != 13 && select != 264)
	{
		clrscr();
		printf(gunN[select-1]); printf("\n");
		printf("\n");
		printf("Manufacturer:\n");
		printf(manuf[select-1]); printf("\n");
		printf("\n");
		printf("Price's range: $"); printf("%ld", prMin[select-1]); printf("-"); printf("%ld", prMax[select-1]); printf("\n");
		printf("\n");
		printf("Description:\n");
		printf(gunD[select-1]);
		printf("\n");
		if  (!hand[select-1])
		{
			printf("Two-handed weapon. ");
		}
		printf("Power: "); printf("%ld", gunP[select-1]);
		ngetchx();
	}
}

int menuPlane()
{
	int select,
			i;
	
	clrscr();
  printf("Take a plane to ...\n");
  printf("\n");
	for (i=0; i<5; i++)
	{
		printf("%d", i+1); printf(". "); printf(loca[i]); printf("\n");
	}
	
	printf("6. Stay here"); printf("\n");
	
	do
	{
		select = ngetchx();
	}
	while (select < 49 || select > 54);
	
	select = select - 49;
	
	if (select != 5)
	{
		cash = cash - 100;
	}
	
	if (cash < 0)
	{
		debt = debt - cash;
		cash = 0;
	}
	return (select);
}

int menuJeu()
{
	int select;

	do
	{
		clrscr();
		printf("Welcome to "); printf(loca[loc]); printf("\n");
		printf("Days left: "); printf("%ld", days); printf("\n");
  	printf("\n");
		printf("1. Take plane\n");
		printf("2. Consult Gun-o-pedia\n");
		printf("3. See your inventory\n");
		printf("4. Sell or buy\n");
		printf("5. Visit loan shark\n");
		printf("\n");
		printf("6. Save and quit\n");
		printf("7. Retire");
	
		select = ngetchx();
		
		switch (select)
		{
			case 50:
			{
				menuPedia();
				break;
			}
			case 51:
			{
				menuInven();
				break;
			}
			case 52:
			{
				menuBuySell();
				break;
			}
			case 53:
			{
				menuLoan();
				break;
			}
			case 55:
			{
				remove("gunsave");
			}
			default:
			{
				select = select - 48;
			}
		}
	}
	while (select != 1 && select != 6 && select != 7);
	
	return(select);
}

int menuMain()
{
	int select;
	
	clrscr();
  printf("Welcome to GunDealer\n");
  printf("\n");
	printf("1. New game\n");
	printf("2. Continue game\n");
	printf("3. About\n");
	printf("\n");
	printf("4. Exit");
	
	do
	{
		select = ngetchx();
	}
	while (select < 49 || select > 52);
	
	switch (select)
	{
		default:
		{
			select = select - 48;
		}
	}
	
	return(select);
}

//Messages
void msgWelcome()
{
	printf("Qusoft proudly presents ...");

	OSFreeTimer(1);
	OSRegisterTimer(1, 20 * 4);
	while (!OSTimerExpired(1));
	
	clrscr();
	printf("Frdric Brown's\n");
  printf("G  U  N     D  E  A  L  E  R\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("Press any key to begin ...");
}

void msgAbout()
{
  printf("Frdric Brown's GunDealer\n");
  printf("Qusoft (C)2001\n");
  printf("\n");
  printf("\n");
  printf("Programmed in C with TI-GCC\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("Press any key to return ...");
}

void msgFinal()
{
	char *msg;
	int i;
	long	score = 0;
			
	
	score = cash - debt;
	
	for (i=0; i<10; i++)
	{
		score = score + (stock[i] * prices[i]);
	}
	
	if (health <= 0)
	{
		msg = "You died!\nTry again ...";
	}
	else
	{	
		if (debt > 0)
		{
			msg = "The loan shark killed you!\nTry again ...";
		}
		else
		{
			if (score > 1000 && score < 100000)
			{
				msg = "Congratulation!\nYou make money ...";
			}
			else
			{
				if (score > 100000 && score < 1000000)
				{
					msg = "Congratulation!\nYOU ARE PRETTY GOOD ...";
				}
				else
				{
					if (score > 1000000)
					{
						msg = "Congratulation!\nYOU ARE A REAL CAID ...";
					}
					else
					{
						msg = "You're a looser!\nTry again";
					}
				}
			}
		}
	}
	
	score = score / 1000;
	
	printf("Your GunDealer game is over!\n");
	printf("\n");
	printf(msg); printf("\n");
	printf("\n");	
	printf("Your score: "); printf("%ld", score);
}

void msgBye()
{
  printf("Thank you for playing\nGunDealer ...");
}

//Fonctions
void saveGame()
{
	int i;
	FILE *fichier;
	
	fichier=fopen("gunsave","wb");
	
		for (i=0; i<11; i++)
		{
			fwrite(&stock[i], sizeof(long), 1, fichier);
		}
		for (i=0; i<10; i++)
		{
			fwrite(&prices[i], sizeof(long), 1, fichier);
		}
		fwrite(&debt, sizeof(long), 1, fichier);
		fwrite(&cash, sizeof(long), 1, fichier);
		fwrite(&loc, sizeof(long), 1, fichier);
		fwrite(&days, sizeof(long), 1, fichier);
		fwrite(&health, sizeof(long), 1, fichier);
		fwrite(&cargo, sizeof(long), 1, fichier);
		fwrite(&cLim, sizeof(long), 1, fichier);
		fwrite(&brwMax, sizeof(long), 1, fichier);
		fwrite(&wepChoice, sizeof(long), 1, fichier);
		fwrite(&nbrChoice, sizeof(long), 1, fichier);
		fwrite(&inter, sizeof(long), 1, fichier);

		fputc (0, fichier);
		fputs ("SAV", fichier);
		fputc (0, fichier);
		fputc (OTH_TAG, fichier);

	fclose(fichier);
}

void loadGame()
{
	int i;
	FILE *fichier;
	
	fichier=fopen("gunsave","rb");
	
		for (i=0; i<11; i++)
		{
			fread(&stock[i], sizeof(long), 1, fichier);
		}
		for (i=0; i<10; i++)
		{
			fread(&prices[i], sizeof(long), 1, fichier);
		}
		fread(&debt, sizeof(long), 1, fichier);
		fread(&cash, sizeof(long), 1, fichier);
		fread(&loc, sizeof(long), 1, fichier);
		fread(&days, sizeof(long), 1, fichier);
		fread(&health, sizeof(long), 1, fichier);
		fread(&cargo, sizeof(long), 1, fichier);
		fread(&cLim, sizeof(long), 1, fichier);
		fread(&brwMax, sizeof(long), 1, fichier);
		fread(&wepChoice, sizeof(long), 1, fichier);
		fread(&nbrChoice, sizeof(long), 1, fichier);
		fread(&inter, sizeof(long), 1, fichier);

	fclose(fichier);
}

BOOL demand()
{
	int key;
	BOOL result = FALSE;

	printf("\n");
	printf("ENTER to accept,\nESC to refuse.");
	
	do
	{
		key = ngetchx();
		
		if (key == 13)
		{
			result = TRUE;
		}
	}
	while (key != 13 && key != 264);
	
	return (result);
}

void battle(char *msg, long cor, long pw)
{
	BOOL temp1;
	long 	temp,
				powr,
				temp0,
				i,
				wep = wepChoice,
				nbr = nbrChoice,
				randMax;
	if (cash > RAND_MAX)
	{
		randMax = RAND_MAX - cor;
	}
	else
	{
		randMax = cash;
	}
	temp = random(randMax) + cor;
	printf(msg);
	printf("Do you accept to pay $"); printf("%ld", temp); printf("\nso they'll close their eyes ?\n");
	printf("Cash: $"); printf("%ld", cash); printf("\n");

	if (nbr == 0)
	{
		wep = 10;
		nbr = 0;
		for (i=0; i<10; i++)
		{
			if ((gunP[i] >= gunP[wep]) && stock[i] >= 1)
			{
				wep = i;
				nbr = 1;
			}
		}
	}

	powr = gunP[wep] * nbr;

	printf(gunN[wep]); printf("\n");
	printf("Power: "); printf("%ld", powr);
	
	temp1 = demand();
	
	if (temp1 && cash >= temp)
	{
		cash = cash - temp;
	}
	
	if (!temp1 || cash < temp)
	{
		clrscr();
		if (temp1)
		{
			printf("You don't have enought cash.\n\n");
		}
		
		temp0 = random(pw) - 5 * powr;
		
		if (temp0 < 0)
		{
			temp0 = 0;
		}
		
		health = health - temp0;
		
		if (health > 0 && nbr > 0)
		{
			printf("You defeat them!\n");
			printf("You loose "); printf("%ld", temp0); printf("%%\n");
			printf("of your health.\n");
			if (cash + cor > RAND_MAX)
			{
				randMax = RAND_MAX;
			}
			else
			{
				randMax = cash + cor;
			}
			temp0 = random(randMax);
			cash = cash + temp0;
			printf("You found $"); printf("%ld", temp0);
		}
		else
		{
			if (health > 0)
			{
				printf("You escape them!\n");
				printf("You loose "); printf("%ld", temp0); printf("%%\n");
				printf("of your health.\n");
			}
			else
			{
				printf("You were defeated!\n");
			}
		}
		
		ngetchx();
	}
}

void event()
{
	BOOL temp1;
	int evNo,
			i,
			nbrStock = nbrChoice;
	long	temp;
	
	for (i=0; i<10; i++)
	{
		nbrStock = nbrStock + stock[i];
	}
	
	evNo = random(16);
	
	switch (evNo)
	{
		case 7:
		{
			evNo = 6;
			break;
		}
		case 8:
		{
			evNo = 5;
			break;
		}
		case 9:
		{
			evNo = 4;
			break;
		}
		case 10:
		{
			evNo = 3;
			break;
		}
		case 11:
		{
			evNo = 3;
			break;
		}
		case 12:
		{
			evNo = 1;
			break;
		}
		case 13:
		{
			evNo = 2;
			break;
		}
	}
	
	switch (evNo)
	{
		case 0:
		{
			temp = random(75);
			printf("You were hit in a shooting!\n");
			printf("You loose "); printf("%ld", temp); printf("%% of your health.");
			health = health - temp;
			ngetchx();
			break;
		}
		case 1:
		{
			temp = random(1500) + 500;
			printf("Do you want to buy\na new cargo for $"); printf("%ld", temp); printf(" ?\n");
			printf("Cash: $"); printf("%ld", cash);
			temp1 = demand();
			if (temp1)
			{
				if (cash >= temp)
				{
					cargo = cargo + 100;
					cash = cash - temp;
				}
				else
				{
					printf("\n\nYou don't have enought cash.");
					ngetchx();
				}
			}
			break;
		}
		case 4:
		{
			printf("Guns' market flooded,\nlow prices ...");
			for (i=0; i<10; i++)
			{
				prices[i] = prices[i] * 2 / 3;
			}
			ngetchx();
			break;
		}
		case 5:
		{
			printf("New gun legislation,\nprices increase ...");
			for (i=0; i<10; i++)
			{
				prices[i] = prices[i] * 3 / 2;
			}
			ngetchx();
			break;
		}
		case 6:
		{
			printf("Street wars are exploding,\npistols' prices increase ...");
			prices[2] = prices[2] * 3;
			prices[4] = prices[4] * 3;
			prices[5] = prices[5] * 3;
			prices[9] = prices[9] * 3;
			ngetchx();
			break;
		}
	}

	switch (loc)
	{
		case 0:
		{
			switch (evNo)
			{
				case 2:
				{
					battle("The GIGN is after you!\n", 3000, 125);
					break;
				}
				case 3:
				{
					printf("FN designed a new rifle,\nFN-FAL prices drop.");
					prices[6] = prices[6] / 2;
					ngetchx();
				}
			}
			break;
		}
		case 1:
		{
			switch (evNo)
			{
				case 2:
				{
					battle("The Spetnaz is after you!\n", 100, 150);
					break;
				}
				case 3:
				{
					printf("The Russian army is doing a\ngarage sell.");
					prices[0] = prices[0] / 3;
					prices[1] = prices[1] / 2;
					prices[2] = prices[2] / 3;
					ngetchx();
					break;
				}
			}
			break;
		}
		case 2:
		{
			switch (evNo)
			{
				case 2:
				{
					battle("The SWAT is after you!\n", 1500, 100);
					break;
				}
				case 3:
				{
					printf("Opening of the NRA congress,\nbuyers will pay fair prices\nfor auto weapons.");
					prices[0] = prices[0] * 3;
					prices[1] = prices[1] * 3;
					prices[3] = prices[3] * 3 / 2;
					prices[4] = prices[4] * 3 / 2;
					prices[6] = prices[6] * 3 / 2;
					prices[7] = prices[7] * 3 / 2;
					prices[9] = prices[9] * 3;
					ngetchx();
					break;
				}
			}
			break;
		}
		case 3:
		{
			switch (evNo)
			{
				case 2:
				{
					battle("The DEA is after you!\n", 1000, 75);
					break;
				}
				case 3:
				{
					printf("A new guerrilla movement is\nfounded. Guerrieros will pay\nwell for old AK and FAL.");
					prices[0] = prices[0] * 3;
					prices[6] = prices[6] * 3;
					ngetchx();
					break;
				}
			}
			break;
		}
		case 4:
		{
			switch (evNo)
			{
				case 2:
				{
					battle("The PLA is after you!\n", 500, 60);
					break;
				}
				case 3:
				{
					printf("China over produced Type 85.\nPrices fall.");
					prices[9] = prices[9] / 3;
					ngetchx();
					break;
				}
			}
			break;
		}
	}

	if (health < 100 && health > 0)
	{
		clrscr();
		temp = (100 - health) * (random(20) + 10);
		printf("A doctor can heal you for\n$"); printf("%ld", temp); printf("\n");
		printf("Health: "); printf("%ld", health); printf("%%"); printf("\n");
		printf("Cash  : $"); printf("%ld", cash);
		temp1 = demand();
		if (temp1)
		{
			if (cash >= temp)
			{
				cash = cash - temp;
				health = 100;
			}
			else
			{
				printf("\n\nYou don't have enought cash.");
				ngetchx();
			}
		}
	}

}

void rndmize()
{
	int key = 0;
	
	clrscr();
	printf("Press any key to stop\nrandomize ...");
	
	do
	{
		randomize();
		if (kbhit())
		{
			key = ngetchx();
		}
	}
	while (key == 0);
}

void rndPrices()
{
	int i;
	
	for (i=0; i<10; i++)
	{
		prices[i] = random(prMax[i] - prMin[i]) + prMin[i];
	}
	
	switch (loc)
	{
		case 0:
		{
			prices[6] = prices[6] * 4 / 5;
			prices[7] = prices[7] * 4 / 5;
			prices[8] = prices[8] * 4 / 5;
			break;
		}
		case 1:
		{
			prices[0] = prices[0] * 2 / 3;
			prices[1] = prices[1] * 2 / 3;
			prices[2] = prices[2] * 2 / 3;
			break;
		}
		case 2:
		{
			prices[3] = prices[3] * 4 / 5;
			prices[4] = prices[4] * 4 / 5;
			prices[5] = prices[5] * 4 / 5;
			break;
		}
		case 3:
		{
			prices[0] = prices[0] * 5 / 4;
			prices[7] = prices[7] * 5 / 4;
			prices[9] = prices[9] * 5 / 4;
			break;
		}
		case 4:
		{
			prices[9] = prices[9] / 2;
			break;
		}
	}
	
	debt = (debt * inter / 100) + debt;
}

void varIni()
{
	int i,
			choix;

	clrscr();
	printf("Select the difficulty level\n\n");
	printf("1. Easy    2. Normal  3. Hard");
	
	do
	{
		choix = ngetchx();
		
		choix = choix - 48;
	}
	while(choix < 1 || choix > 3);
	
	switch (choix)
	{
		case 1:
		{
			for (i=0; i<10; i++)
			{
				stock[i] = 0;
			}
			debt = 0;
			cash = 1000;
			loc = 2;
			days = 61;
			health = 100;
			cargo = 100;
			cLim = 25000;
			wepChoice = 10;
			nbrChoice = 0;
			inter = 6;
			break;
		}
		case 2:
		{
			for (i=0; i<10; i++)
			{
				stock[i] = 0;
			}
			debt = 1000;
			cash = 1000;
			loc = 2;
			days = 31;
			health = 100;
			cargo = 100;
			cLim = 10000;
			wepChoice = 10;
			nbrChoice = 0;
			inter = 8;
			break;
		}
		case 3:
		{
			for (i=0; i<10; i++)
			{
				stock[i] = 0;
			}
			debt = 1000;
			cash = 1000;
			loc = 2;
			days = 31;
			health = 100;
			cargo = 100;
			cLim = 0;
			wepChoice = 10;
			nbrChoice = 0;
			inter = 10;
			break;
		}
	}

}

void boucleJeu()
{
	int		choix = 0,
				temp;
	
	do
	{
		if (days > 0 && health > 0)
		{			
			if (health > 0)
			{
				choix = menuJeu();
			
				if (choix == 1)
				{
						temp = menuPlane();
						if (temp != 5)
						{
							loc = temp;
						}
						days--;
				}
			}
			if (days > 0 && health > 0 && choix < 6)
			{
				rndPrices();
				clrscr();
				event();
			}
		}
		else
		{
			clrscr();
			msgFinal();
			ngetchx();
			choix = 6;
		}
	}
	while (choix < 6);
	switch (choix)
	{
		case 6:
		{
			saveGame();
			break;
		}
		case 7:
		{
			clrscr();
			msgFinal();
			ngetchx();
			break;
		}
	}
}

void startGame()
{	
	rndmize();
	rndPrices();
	varIni();
	clrscr();
	event();

	boucleJeu();
}

void contGame()
{
	BOOL ok = TRUE;
	FILE *f;
	
	f = fopen("gunsave", "r");
	
	if (f == NULL)
	{
		ok = FALSE;
	}
	
	fclose(f);
	
	if (ok)
	{
		rndmize();
		loadGame();
		clrscr();

		boucleJeu();
	}
}

// Main Function
void _main()
{
	//Dclaration des variables
	int choix;
	
	if (TI89) {
		FontSetSys(F_4x6);
	}
	
	clrscr();
	msgWelcome();
	ngetchx();

	do
	{  
  	choix = menuMain();
  	switch(choix)
  	{
  		case 1:
  		{
  			startGame();
  			break;
  		}
  		case 2:
  		{
  			contGame();
  			break;
  		}
  		case 3:
  		{
  			clrscr();
  			msgAbout();
  			ngetchx();
  			break;
  		}
  	}
  }
  while (choix != 4);

  clrscr();
  msgBye();
  ngetchx();
}
